import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

public class PlaneArea extends myFilter{

	public boolean[][] map;
    JButton b_clear,b_take;
    int xs,ys;
    // we save old resize offset, to see if user has unzoomed
    int xoffs=0;
    int yoffs=0;
	
	PlaneArea(Stml.F_topo f){
        super(f);

        int xco,yco;
        
        xs=f_topo.im_xsize;
        ys=f_topo.im_ysize;
        map=new boolean[xs][ys];
        for(yco=0;yco<ys;yco++) 
          for(xco=0;xco<xs;xco++) 
            map[xco][yco]=false;
    	b_clear=new JButton(" Clear ");
    	b_take=new JButton(" Takeover ");
    	p_ptool=new Panel();
    	p_ptool.setVisible(false);
    	p_ptool.setLayout(new GridBagLayout());
    	GridBagConstraints c=new GridBagConstraints();
        c.fill=GridBagConstraints.BOTH;
        c.insets=new Insets(5,5,5,5);
        c.weightx=c.weighty=0.0;
        c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(b_clear ,c);
        c.gridx=0;c.gridy=1;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(b_take ,c);
        ActionListener parea_al=new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int xco,yco; 
            	String command=e.getActionCommand();
                if(command.equals("clear")) {
                	for(yco=0;yco<ys;yco++) 
                        for(xco=0;xco<xs;xco++) { 
                          f_topo.map[xco][yco]=false;
                          map[xco][yco]=false;
                        }
                    f_topo.updateframe(f_topo.p_topo);
                  }
                if(command.equals("take")) {
                	for(yco=0;yco<ys;yco++) 
                        for(xco=0;xco<xs;xco++) 
                          map[xco][yco]=f_topo.map[xco][yco];
                	f_topo.updateframe(f_topo.p_topo);
                  }
            }
          };
          b_clear.setActionCommand("clear");
          b_clear.addActionListener(parea_al);
          b_take.setActionCommand("take");
          b_take.addActionListener(parea_al);
          f_topo.add(p_ptool);

	}
	
	public void resize(int xsize,int ysize,int xofs,int yofs) {
        int xco,yco;
        boolean oldmap[][];

        oldmap=new boolean[xs][ys];
    	for(yco=0;yco<ys;yco++) 
    		for(xco=0;xco<xs;xco++)
    			oldmap[xco][yco]=map[xco][yco];
        if ((xsize>xs) && (ysize>ys) && ((xofs+yofs)==0)) {
        	map=new boolean[xsize][ysize];
        	for(yco=0;yco<ysize;yco++) 
        		for(xco=0;xco<xsize;xco++) 
        			map[xco][yco]=false;
        	for(yco=0;yco<ys;yco++) 
        		for(xco=0;xco<xs;xco++) 
        			map[xco+xoffs][yco+yoffs]=oldmap[xco][yco];
        	xoffs=xofs;
        	yoffs=yofs;
        	xs=xsize;
        	ys=ysize;
        } else {
        	xoffs=xofs;
        	yoffs=yofs;
        	xs=xsize;
        	ys=ysize;
        	map=new boolean[xs][ys];
        	for(yco=0;yco<ysize;yco++) 
        		for(xco=0;xco<xsize;xco++) 
        			map[xco][yco]=oldmap[xco+xofs][yco+yofs];
        }
	}

	public void enabletool() {
        int xco,yco;
        
		for(yco=0;yco<ys;yco++) 
            for(xco=0;xco<xs;xco++) 
              f_topo.map[xco][yco]=map[xco][yco];
		f_topo.b_planear=true;
		f_topo.b_areamarker=true;
		p_ptool.setVisible(true);
	}

	public void doit(){
        int xco,yco,datum;
        boolean flag;
        double da,db,dc,dd,de,df,dg,dh,di,dj,dk,dl;
        double rA=0,rB=0,rC=0;
        double ddet;
/*        
N data points

z=A+Bx+Cy
(A+Bx+Cy-z)^2 -> min

A^2+ABx+ACy-Az+
ABx+B^2x^2+BCxy-Bxz+
ACy+BCxy+C^2y^2-Cyz+
-Az-Bxz-Cyz+z^2

A^2+2ABx+2ACy-2Az+B^2x^2+2BCxy-2Bxz+C^2y^2-2Cyz+z^2

partial and set 0
df
-- = 2AN+2Bx+2Cy-2z = 0
dA

df
-- = 2Ax+2Bxx+2Cxy-2xz
dB

df
-- = 2Ay+2Bxy+2Cyy-2yz
dC

System brackets [] are sums from i=0..N :

  N  [x]  [y]    A    [z]
 [x] [xx] [xy]   B  = [xz]
 [y] [xy] [yy]   C    [yz]
 
for small program Cramers Rule:
    D1
A = --  with Determinant D1 is D with first row replaced by [z] [xz] [yz] (perpendicular)
    D

    D2
B = -- with second row replaced a.s.o.
    D
    
solution of determinant by rule of sarrus:
     a b c 
det  d e f = aei+bfg+cdh - (ceg+afh+bdi)
     g h i
    
*/
        
// check if any point is selected
        flag=false;
        for(yco=0;yco<ys;yco++) 
            for(xco=0;xco<xs;xco++) 
              if (map[xco][yco]) flag=true;
        if (!flag) return;
        da=db=dc=dd=de=df=dg=dh=di=dj=dk=dl=0;
// calculate coefficient sums
        for(yco=0;yco<ys;yco++) 
            for(xco=0;xco<xs;xco++) 
              if (map[xco][yco]) {
            	  datum=f_topo.workdata[xco][yco];
            	  da++;
            	  db+=xco;
            	  dc+=yco;
//            	  dd+=xco;
            	  de+=(xco*xco);
               	  df+=(xco*yco);
//                dg+=yco;
//             	  dh+=(xco*yco);
               	  di+=(yco*yco);
               	  dj+=datum;
               	  dk+=(xco*datum);
               	  dl+=(yco*datum);
              }
        dd=db;
        dg=dc;
        dh=df;
        ddet=det(da,db,dc,dd,de,df,dg,dh,di);
        if (ddet!=0) {
        	rA=det(dj,db,dc,dk,de,df,dl,dh,di)/ddet;
        	rB=det(da,dj,dc,dd,dk,df,dg,dl,di)/ddet;
        	rC=det(da,db,dj,dd,de,dk,dg,dh,dl)/ddet;
        } else {
        	System.out.println("PlaneArea: Determinant==0 !");
        }
        for(yco=0;yco<ys;yco++) 
            for(xco=0;xco<xs;xco++) 
              f_topo.workdata[xco][yco]-=(rA+rB*xco+rC*yco);
	}
	
	double det(double a,double b,double c,double d,double e,double f,double g,double h,double i) {
		return (a*e*i+b*f*g+c*d*h)-(c*e*g+a*f*h+b*d*i);
	}
        
}
