import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.*;

public class PlaneArea2 extends myFilter {
    double par_aline2=0.7;
    JLabel l_aline2;
    TextField tf_aline2;
	public boolean[][] map;
    JButton b_clear,b_take;
    Checkbox cb_show;
    int xs,ys;
    // we save old resize offset, to see if user has unzoomed
    int xoffs=0;
    int yoffs=0;
    boolean b_show=false;

	PlaneArea2(Stml.F_topo f){
        super(f);

        int xco,yco;
        
        xs=f_topo.im_xsize;
        ys=f_topo.im_ysize;
        map=new boolean[xs][ys];
        for(yco=0;yco<ys;yco++) 
          for(xco=0;xco<xs;xco++) 
            map[xco][yco]=false;

        //		 Antiline 3 Panel
        p_ptool=new Panel();
        p_ptool.setLayout(new GridBagLayout());
        GridBagConstraints c=new GridBagConstraints();
        c.fill=GridBagConstraints.BOTH;
        c.insets=new Insets(5,5,5,5);
        c.weightx=c.weighty=0.0;
        
        l_aline2=new JLabel("Strength: ");
        tf_aline2=new TextField(""+par_aline2);
        c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(l_aline2 ,c);
        c.gridx=1;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(tf_aline2 ,c);
        cb_show=new Checkbox("Show excluded points");
        c.gridx=0;c.gridy=1;c.gridwidth=2;c.gridheight=1;
        p_ptool.add(cb_show ,c);
        
    	b_clear=new JButton(" Clear ");
    	b_take=new JButton(" Takeover ");
        c.gridx=0;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(b_clear ,c);
        c.gridx=0;c.gridy=3;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(b_take ,c);
    	
        p_ptool.setVisible(false);
        ActionListener tf_al=new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            par_aline2=-1;
            try {
              par_aline2=Double.parseDouble(tf_aline2.getText());
            } catch (NumberFormatException ex) {
              System.out.println("NumberFormatException: "+ex.getMessage());
            }
            if ((par_aline2>0) && (par_aline2<=1)) f_topo.updateframe(f_topo.p_topo);
          }
        };
        tf_aline2.addActionListener(tf_al);
        ItemListener m_il=new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
            	if (e.getItemSelectable().equals(cb_show)) {
                b_show=cb_show.getState();
                f_topo.updateframe(f_topo.p_topo);
              }
            }
        };
        cb_show.addItemListener(m_il);
        ActionListener parea_al=new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int xco,yco; 
            	String command=e.getActionCommand();
                if(command.equals("clear")) {
                	for(yco=0;yco<ys;yco++) 
                        for(xco=0;xco<xs;xco++) { 
                          f_topo.map[xco][yco]=false;
                          map[xco][yco]=false;
                        }
                    f_topo.updateframe(f_topo.p_topo);
                  }
                if(command.equals("take")) {
                	for(yco=0;yco<ys;yco++) 
                        for(xco=0;xco<xs;xco++) 
                          map[xco][yco]=f_topo.map[xco][yco];
                	f_topo.updateframe(f_topo.p_topo);
                  }
            }
          };
          b_clear.setActionCommand("clear");
          b_clear.addActionListener(parea_al);
          b_take.setActionCommand("take");
          b_take.addActionListener(parea_al);
        
        f_topo.add(p_ptool);
	}
	
	public void resize(int xsize,int ysize,int xofs,int yofs) {
        int xco,yco;
        boolean oldmap[][];

        oldmap=new boolean[xs][ys];
    	for(yco=0;yco<ys;yco++) 
    		for(xco=0;xco<xs;xco++)
    			oldmap[xco][yco]=map[xco][yco];
        if ((xsize>xs) && (ysize>ys) && ((xofs+yofs)==0)) {
        	map=new boolean[xsize][ysize];
        	for(yco=0;yco<ysize;yco++) 
        		for(xco=0;xco<xsize;xco++) 
        			map[xco][yco]=false;
        	for(yco=0;yco<ys;yco++) 
        		for(xco=0;xco<xs;xco++) 
        			map[xco+xoffs][yco+yoffs]=oldmap[xco][yco];
        	xoffs=xofs;
        	yoffs=yofs;
        	xs=xsize;
        	ys=ysize;
        } else {
        	xoffs=xofs;
        	yoffs=yofs;
        	xs=xsize;
        	ys=ysize;
        	map=new boolean[xs][ys];
        	for(yco=0;yco<ysize;yco++) 
        		for(xco=0;xco<xsize;xco++) 
        			map[xco][yco]=oldmap[xco+xofs][yco+yofs];
        }
	}
	
	public void enabletool() {
        int xco,yco;
        
		for(yco=0;yco<ys;yco++) 
            for(xco=0;xco<xs;xco++) 
              f_topo.map[xco][yco]=map[xco][yco];
		f_topo.b_planear=true;
		f_topo.b_areamarker=true;
		p_ptool.setVisible(true);
	}

	public void doit() {
        int xco,yco,d,i;
//      int i1,i2;
      int maxd,dhist[],dcapu,dcapo,xcap;
//      int off;
      int minb,maxb;
      int im_xsize,im_ysize;
      byte testdata[][];
      
      double strength=par_aline2;
      
      im_xsize=f_topo.im_xsize;
      im_ysize=f_topo.im_ysize;

      testdata=new byte[im_xsize][im_ysize];
      for(yco=1;yco<im_ysize;yco++) { // die 0te Linie dient als Bezug, da es die LETZTE Messlinie ist
// stoerungen treten verstaerkt bei der letzten auf - also die erste gemessene...
        xcap=(int) (strength*im_xsize);
        maxd=Integer.MIN_VALUE;
        for(xco=0;xco<im_xsize;xco++) {
          d=Math.abs(f_topo.workdata[xco][yco]-f_topo.workdata[xco][yco-1]);
          if (d>maxd) maxd=d;
        }
        dhist=new int[maxd+1]; // array fuer histogram der deltas anlegen
        for(xco=0;xco<dhist.length;xco++) dhist[xco]=0; // mit 0 fuellen
        for(xco=0;xco<im_xsize;xco++) {
          d=Math.abs(f_topo.workdata[xco][yco]-f_topo.workdata[xco][yco-1]);
          dhist[d]++;
        } // und histogram erzeugen
//hier muss eine fenstersuche hin
        dcapo=dcapu=0;
        i=Integer.MAX_VALUE;
        d=0;
        minb=maxb=maxd;
        d+=dhist[minb];
        while(minb>0) {  // xcap = xsize * strength
          while ((minb>0) && (d<xcap)) {
            minb--; // minb zaehlt runter bis xcap erreicht ist
            d+=dhist[minb]; // in d wird volumen summiert
          } // wenn d gerade ueber xcap ist -> minb festgelegt
          while ((maxb>=minb) && (d>=xcap)) {
            d-=dhist[maxb]; // hier wird die obergrenze des fensters gesucht, da minb und maxb nicht 
            maxb--; // synchron laufen und es von der Anzahl Werte einer Klasse bestimmt wird
          }
//System.out.println("Aline2: yco "+yco+" minb "+minb+" maxb "+maxb+" d "+d+" xcap "+xcap);
          if (i>(maxb-minb)) { // hier wird der beste fall herausgesucht mit geringster Ausdehnung im histogram
            i=maxb-minb;
            dcapu=minb;
            dcapo=maxb+1;
          }
        }
        for(xco=0;xco<im_xsize;xco++) {
          i=Math.abs(f_topo.workdata[xco][yco]-f_topo.workdata[xco][yco-1]);
          if ((i<dcapo) && (i>=dcapu)) { // delta im optimalen bereich?
            testdata[xco][yco]=1;
          } else {
            testdata[xco][yco]=0;
          }
        }
      }
//      System.out.println("Aline2 ready.");
      // now do planearea
      int datum;
      boolean flag;
      double da,db,dc,dd,de,df,dg,dh,di,dj,dk,dl;
      double rA=0,rB=0,rC=0;
      double ddet;

      //    check if any point is selected
      flag=false;
      for(yco=0;yco<ys;yco++) 
          for(xco=0;xco<xs;xco++) 
            if (map[xco][yco] && (testdata[xco][yco]==1)) flag=true;
      if (!flag) return;
      da=db=dc=dd=de=df=dg=dh=di=dj=dk=dl=0;
//calculate coefficient sums
      for(yco=0;yco<ys;yco++) 
          for(xco=0;xco<xs;xco++) 
            if (map[xco][yco] && (testdata[xco][yco]==1)) {
          	  datum=f_topo.workdata[xco][yco];
          	  da++;
          	  db+=xco;
          	  dc+=yco;
//          	  dd+=xco;
          	  de+=(xco*xco);
             	  df+=(xco*yco);
//              dg+=yco;
//           	  dh+=(xco*yco);
             	  di+=(yco*yco);
             	  dj+=datum;
             	  dk+=(xco*datum);
             	  dl+=(yco*datum);
            }
      dd=db;
      dg=dc;
      dh=df;
      ddet=det(da,db,dc,dd,de,df,dg,dh,di);
      if (ddet!=0) {
      	rA=det(dj,db,dc,dk,de,df,dl,dh,di)/ddet;
      	rB=det(da,dj,dc,dd,dk,df,dg,dl,di)/ddet;
      	rC=det(da,db,dj,dd,de,dk,dg,dh,dl)/ddet;
      } else {
      	System.out.println("PlaneArea2: Determinant==0 !");
      }
      for(yco=0;yco<ys;yco++) 
          for(xco=0;xco<xs;xco++) 
            f_topo.workdata[xco][yco]-=(rA+rB*xco+rC*yco);
      if (b_show) {
          for(yco=0;yco<ys;yco++) 
              for(xco=0;xco<xs;xco++) 
                if (testdata[xco][yco]==0) f_topo.workdata[xco][yco]=f_topo.max_ad;
      }

      
	}

	double det(double a,double b,double c,double d,double e,double f,double g,double h,double i) {
		return (a*e*i+b*f*g+c*d*h)-(c*e*g+a*f*h+b*d*i);
	}

}
